import { dictionaryDeleteAll } from "@/api/path/dict.js";
import { ref } from "vue";
// 获取字典
export function Getdictionary(params) {
    if (Array.isArray(params)) {
        // 存储每个请求的 Promise
        const promises = params.map(item => {
            return dictionaryDeleteAll({ typeKey: item }).then((res) => {
                return res.data;
            });
        });
        // 使用 Promise.all 处理多个请求
        return Promise.all(promises).then(results => {
            return results;
        });
    } else {
        // 非数组时，直接请求
        return dictionaryDeleteAll({ typeKey: params }).then((res) => {
            return res.data;
        });
    }
}

// 过滤字典值
export function filterDict(item, value) {
    if (!Array.isArray(item)) return false
    return item.find(val => val.value == value)?.label
}

// 处理表格分页 && 搜索 && 搜索表单重置 && 及请求到的数据公共处理方法
export function tableFunction(_this, apiRequest, processData) {
    // 表格数据
    const tableData = ref([]);
    // 搜索数据
    const SearchForm = ref({});

    // 请求数据方法，使用外部传入的 apiRequest 方法
    const initData = async (item) => {
        if (item) {
            SearchForm.value = item;
        }
        const param = {
            ..._this,
            ...SearchForm.value // 搜索使用的方法
        };
        delete param.pageSize
        param.size = _this.pageSize
        // 调用外部传入的请求方法，并传递分页参数
        const res = await apiRequest(param);
        if (res.code === 200) {
            // 使用外部的方法来处理值
            tableData.value = processData ? await processData(res.data) : res.data.records || res.data;
            _this.total = res.data.total;
        }
    };

    // 分页变化时的处理方法
    const evChangePage = (e) => {
        _this.current = e;
        initData();  // 调用请求数据方法
    };

    // 表单重置
    const reset = (item) => {
        SearchForm.value = item;
        _this.current = 1;
        initData();
    };

    // 将事件处理方法暴露给组件
    return {
        evChangePage,
        initData,
        reset,
        tableData,
        SearchForm
    };
}